'''
Created on 27.2.2018

@author: lamour
'''
from numpy import array,zeros as npzeros
from example_car_axis_ import Example_car_axis

from IntegrationDAE.DAE_TaylorIntegration import TaylorIntegration
from matplotlib.pyplot import plot,show,legend,figure,title
ex = Example_car_axis()

n = 10
K = 8
t0= 0.

L   = 1e0
L0  = 0.5e0

xr   = L
xl   = 0
yr   = L0
yl   = yr
xra  = -L0/L
xla  = xra
yra  = 0e0
yla  = 0e0
lam1 = 0e0
lam2 = 0e0


alpha=array([xl,yl,xr,yr,xla,yla,xra,yra,lam1,lam2])
print ('Solution by minimization')
print ('alpha = ',alpha)
ftola=1e-10
X0=npzeros(K*n)
X0[:n]=alpha

Taylorex=TaylorIntegration(ex,K,tol=None,info_output='001', method=3)

T=3.
#T=1.
#ftola=1e-12

x0=npzeros(K*n)
x0[:n]=alpha

omega=10.
NumSteps=100

#yxout,tlist,indexList,condList=Taylorex.Taylor_integration_constant_h(t0,alpha,T,NumSteps,ftol=ftola,max_iterations=100)
 
yxout,tlist,indexList,condList=Taylorex.Taylor_integration_adaptiveStep(t0,T,alpha,disp=False,ftol=ftola,RobustIntegration=False,max_iterations=100)


if yxout is None:
    exit()
print (indexList)
print (condList)
figure(0)

plot(tlist,condList,label='cond')
legend(loc='upper right', shadow=True)
title('Car axis')

tlist=tlist/omega
#print 'tlist = ',tlist
figure(1)
plot(tlist,yxout[:,0],label='x1')
plot(tlist,yxout[:,1],label='x2')
plot(tlist,yxout[:,2],label='x3')
plot(tlist,yxout[:,3],label='x4')
#plot(tlist,yxout[:,4]*omega,label='x5')
#plot(tlist,yxout[:,5]*omega,label='x6')
#plot(tlist,yxout[:,6]*omega,label='x7')
#plot(tlist,yxout[:,7]*omega,label='x8')
#plot(tlist,yxout[:,8],label='x9')
#plot(tlist,yxout[:,9],label='x10')
legend(loc='upper right', shadow=True)
title('Car axis')
show()
