from numpy import array, zeros as npzeros
from IntegrationDAE.DAE_TaylorIntegration import TaylorIntegration

from example_pendulum_u_main import Example_pendulum
ex = Example_pendulum()
n=5
K=10
print ('Solution by minimization')
Taylorex=TaylorIntegration(ex,K,tol=None,info_output='001',method=3)

alpha=array([.5, .5, 0.,0., 0.])
print ('alpha = ',alpha)
t0=0.
T=3.#7.#20.
ftola=1e-12

x0=npzeros(K*n)
x0[:n]=alpha

#NumSteps=100
#yxout,tlist,indexList,condList=Taylorex.Taylor_integration_constant_h(t0,alpha,T,NumSteps,ftol=ftola,max_iterations=300)
yxout,tlist,indexList,condList=Taylorex.Taylor_integration_adaptiveStep(t0,T,alpha,disp=False,tol=1e-7,hstart=1e-6,max_iterations=200)
if yxout is None:
    exit()
print ('indexlist = ',indexList)
print ('condlist = ',condList)
print ('tlist = ',tlist)

Taylorex.plot_figure(tlist,yxout,'x',xlab='t',ylog=False)
Taylorex.plot_figure(tlist,condList,'condition number',xlab='t',ylog=False)
Taylorex.plot_figure(yxout[:,0],yxout[:,1],'phase portrait',xlab='x1',ylog=False)

print ('check_solution_along_path++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++')
path='pendulum_index3_integr_2020-05-12.sol'
print ('path = ',path)
tliste,index,condM=Taylorex.check_solution_along_path(path)
Taylorex.plot_figure(tliste,condM,'condition number from external data',xlab='t',ylog=False)


