from numpy import array,exp as npexp, zeros as npzeros,cos,sin,shape
#from DAEinitialization.consistentValues import consistentValuesIndex
from IntegrationDAE.DAE_TaylorIntegration import TaylorIntegration
from example_roboticArm_standard import RoboticArmStandard
from RoboticArmLoesung import RoboticArmSolution
from matplotlib.pyplot import plot,show,legend,figure,ylabel

ex = RoboticArmStandard()
n=8
K=10
print ('Solution by minimization')
Taylorex=TaylorIntegration(ex,K,tol=None,info_output='100',method=4)
print ('main',Taylorex.info_output)

t0=0.

expt0=npexp(t0)
x1=1.-expt0
x3=expt0-t0
x4=-expt0
x6=expt0-1.

alpha=array([x1, 0, x3,0, 0, 0, 0, 0])
print ('alpha = ',alpha)
T=1.43
ftola=1e-12

x0=npzeros(K*n)
x0[:n]=alpha

yxout,tlist,indexList,condList=Taylorex.Taylor_integration_adaptiveStep(t0,T,alpha,disp=False,tol=1e-4,RobustIntegration=False,max_iterations=100)
if yxout is None:
    exit()
print (indexList)
print (condList)
sol=1.0-npexp(tlist)
print ('tlist = ',tlist)
figure(0)
plot(tlist,yxout[:,0],label='x1')
plot(tlist,yxout[:,1],label='x2')
plot(tlist,yxout[:,2],label='x3')
plot(tlist,yxout[:,3],label='x4')
plot(tlist,yxout[:,4],label='x5')
plot(tlist,yxout[:,5],label='x6')
plot(tlist,yxout[:,6],label='u1')
plot(tlist,yxout[:,7],label='u2')
legend(loc='upper left', shadow=True)
ylabel('solution')
show()
#exit()
solution,abl=RoboticArmSolution(tlist)

figure(1)
plot(tlist,yxout[:,0]-solution[0],label='x1-sol')
legend(loc='upper left', shadow=True)
#show()
figure(2)
plot(tlist,yxout[:,1]-solution[1],label='x2-sol')
legend(loc='upper left', shadow=True)
#show()
figure(3)
plot(tlist,yxout[:,2]-solution[2],label='x3-sol')
legend(loc='upper left', shadow=True)
#show()
figure(4)
plot(tlist,yxout[:,3]-solution[3],label='x4-sol')
legend(loc='upper left', shadow=True)
#show()
figure(5)
plot(tlist,yxout[:,4]-solution[4],label='x5-sol')
legend(loc='upper left', shadow=True)
#show()
figure(6)
plot(tlist,yxout[:,5]-solution[5],label='x6-sol')
legend(loc='upper left', shadow=True)
#show()
figure(7)
plot(tlist,yxout[:,6]-solution[6],label='x7-sol')
legend(loc='upper left', shadow=True)
#show()
figure(8)
plot(tlist,yxout[:,7]-solution[7],label='x8-sol')
legend(loc='upper left', shadow=True)
#show()

figure(9)
plot(tlist,condList,label='condition')
legend(loc='upper left', shadow=True)
show()
